﻿<?php
/*------------------------------------------------------------------------
# Yt Twitter - Version 1.0
# ------------------------------------------------------------------------
# author    YouTech Company
# copyright Copyright (C) 2010 ytcvn.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.ytcvn.com
# Technical Support:  Forum - http://www.ytcvn.com/forums.html
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' ); 

jimport('joomla.filesystem.file');
$mainframe	= &JFactory::getApplication();
$document		= &JFactory::getDocument();

// Assign paths
$sitePath		= JPATH_SITE;
$siteUrl  	= substr(JURI::base(), 0, -1);

// Module parameters
$intro = $params->get('intro_text','');
$footer = $params->get('footer_text','');
$moduleclass_sfx 	= $params->get('moduleclass_sfx','');
$preloadtimeout		= (int) $params->get('preloadtimeout',2) * 1000;
$tweetusername 		= strtolower(trim($params->get('twitteruser','ytcvn')));
$numcountdisplay	= (int) $params->get('numcountdisplay',5);
$tweet_title	    = $params->get('tweet_title','My tweets');
$module_width	    = intval($params->get('module_width','250'));
 
// Output some Twitter API stuff to the document's head
$headerScripts = "
	function yttwitterId".$module->id."(tweets) {
	
	  var statusHTML = [];
	  
	  for(var i=0; i<tweets.length; i++) {
	    var username = tweets[i].user.screen_name;
	    var status = tweets[i].text.replace(/((https?|s?ftp|ssh)\:\/\/[^\"\s\<\>]*[^.,;'\">\:\s\<\>\)\]\!])/g, function(url) {
	      return '<a target=\"_blank\" href=\"'+url+'\">'+url+'</a>';
	    }).replace(/\B[@＠]([a-zA-Z0-9_]{1,20})/g, function(reply) {
	      return '<a target=\"_blank\" href=\"http://twitter.com/'+reply.substring(1)+'\">@'+reply.substring(1)+'</a>';
	    }).replace(/(^|\s+)#(\w+)/gi, ' <a target=\"_blank\" href=\"http://twitter.com/search?q=%23$2\">&#035;$2</a>');
	    
	    if(status.substr(0,1)==' ') status = status.substring(1);
	    
	    if(i%2==1) var liClass = 'even'; else var liClass = 'odd';
	    
	    var liOutput = '\
		    <li class=\"'+liClass+'\">\
			    <span class=\"userstatus\">'+status+'</span>\
			    <br />\
			    <a target=\"_blank\" class=\"ltStatusTimestamp\" href=\"http://twitter.com/'+username+'/status/'+tweets[i].id_str+'\">\
			    	'+relative_time(tweets[i].created_at)+'\
			    </a>\
		    </li>\
	    ';
	    
	    statusHTML.push(liOutput);
	  }
	  
	  setTimeout(function(){document.getElementById('twitterlist".$module->id."').innerHTML = statusHTML.join('');},".$preloadtimeout.");
	}
	
	function relative_time(time_value) {
	  var values = time_value.split(\" \");
	  time_value = values[1] + \" \" + values[2] + \", \" + values[5] + \" \" + values[3];
	  var parsed_date = Date.parse(time_value);
	  var relative_to = (arguments.length > 1) ? arguments[1] : new Date();
	  var difference = parseInt((relative_to.getTime() - parsed_date) / 1000);
	  difference = difference + (relative_to.getTimezoneOffset() * 60);
	
	  if (difference < 60) {
	    return '".JText::_('less than a minute ago')."';
	  } else if(difference < 120) {
	    return 'about a minute ago';
	  } else if(difference < (60*60)) {
	    return (parseInt(difference / 60)).toString() + ' ".JText::_('minutes ago')."';
	  } else if(difference < (120*60)) {
	    return 'about an hour ago';
	  } else if(difference < (24*60*60)) {
	    return 'about ' + (parseInt(difference / 3600)).toString() + ' ".JText::_('hours ago')."';
	  } else if(difference < (48*60*60)) {
	    return '1 day ago';
	  } else {
	    return (parseInt(difference / 86400)).toString() + ' ".JText::_('days ago')."';
	  }
	}
	
	window.addEvent('domready', function() {
		var twitterScript = document.createElement('script');
		twitterScript.setAttribute('charset','utf-8');
		twitterScript.setAttribute('type','text/javascript');
		twitterScript.setAttribute('src','http://twitter.com/statuses/user_timeline.json?screen_name=".$tweetusername."&count=".$numcountdisplay."&callback=yttwitterId".$module->id."');
		var b = document.getElementsByTagName('body')[0];
		b.appendChild(twitterScript);
	});
";
$document->addScriptDeclaration($headerScripts);

$document->addStyleSheet($siteUrl.'/modules/mod_yt_twitter/assets/style.css');

require(JModuleHelper::getLayoutPath('mod_yt_twitter'));
